import logging

import turbogears
from turbogears import controllers, expose
from turbogears import flash, redirect, url
from turbogears import config
from paraxip.gateway_gui import extjs

import netborderPyThread

log = logging.getLogger("pstnconfig")

class StatusController(controllers.Controller):    
  def __init__(self):
    self._strServiceName = config.get('netborder.oamWebServer.gwServiceName')
    if  self._strServiceName == None:
      log.error("Can't find name of gateway service in configuration. "
                 "Ensure that netborder.oamWebServer.gwServiceName is set "
                 "in configuration.")
      # Let's try Netborder Gateway ...
      self._strServiceName = "Netborder Gateway"
    log.debug("GW service name = %s",self._strServiceName)
    controllers.Controller.__init__(self)

  @expose(template='pstnconfig.templates.status.status')
  def index (self):
    """Displays the status of the gateway using http get to localhost:7782/script/vital_sign.esp"""
    gwStarted = self.isGatewayStarted("feafea")
    return {}

  @expose()
  def restartGateway(self, _dc='None', js=''):
    self.stopGateway()
    if self.startGateway():
      return {'success':True}
    else:
      return {'success':False,'errorMsg':'Failed to start the gateway. See log file for details.'}
     
  @expose()
  def stopGatewayButton (self, _dc='None', js=''):
    return {"value":self.stopGateway()}
    
  def stopGateway(self):
    log.info("Stopping service")
    return netborderPyThread.stopService(self._strServiceName)

  @expose()
  def startGatewayButton (self, _dc='None', js=''):
    return {"value":self.startGateway()}

  def startGateway(self):
    log.info("nStarting service")
    return netborderPyThread.startService(self._strServiceName)
      
  @expose()
  def isGatewayStarted(self, _dc='None', js=''):
    return {"value":self.isGWStarted()}

  def isGWStarted(self):
    return netborderPyThread.isServiceStarted(self._strServiceName)  
