//Ext.QuickTips.init();

//-----------------------------------------------
// Add/Delete Channel Group methods
//-----------------------------------------------
function addChanGroupHandler(){
  addChannelGroupWindow.show();
};

function addChanGroup(){
  var form = addChannelGroupForm.getForm();
  var el  = form.getEl();

  el.dom.action = "config/addChannelGroup";
  el.dom.method = 'POST';
  var channelGroup = Ext.util.JSON.encode(form.getValues());
  form.submit({
    params: {'channelGroup':channelGroup},
    success: function(){
      addChannelGroupWindow.hide();
      //gridChannelGroup.store.reload();
      reloadTree(true);
    },
    failure: Paraxip.failureMessage
  });
};

function deleteChanGroupHandler(){
  var selectedRecords = gridChannelGroup.getSelectionModel().getSelections();

  if (selectedRecords !== []) {
    if ( gridChannelGroup.store.getCount() - selectedRecords.length < 1 ){
      Ext.Msg.alert("Can not delete last channelGroup!",
        "At least one channelGroup is necessary for the system to work properly. " +
        "Please edit current config or create a new one before deleting " +
        "this one");
    } else {
      var channelGroups = new Array();
      for (var i = 0; i < selectedRecords.length; i++) {
        channelGroups.push(selectedRecords[i].data);
      }
      channelGroups = Ext.util.JSON.encode(channelGroups);
      Ext.Ajax.request({
        url: 'config/deleteChannelGroup',
        method: 'POST',
        disableCaching: false,
        params: {"channelGroups":channelGroups},
        success: function ()
        {
          for (var index = 0; index < selectedRecords.length; index++) {
            gridChannelGroup.store.remove(selectedRecords[index]);
          }
          reloadTree(true);
        },
        failure: Paraxip.failureMessage
      });
    }
  }
};
var newChanGrpID = new Ext.form.TextField({
  xtype       : 'textfield',
  fieldLabel  : "ID",
  name        : "id",
  width       : 145 ,
  allowBlank  : false
});

var newChanGrpDirection = new Ext.form.ComboBox({
  xtype           : 'combobox',
  name            : 'direction',
  fieldLabel      : "Direction",
  store           : ['IN','OUT', 'BIDIR'],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  selectOnFocus   : true,
  width           : 145,
  minListWidth    : 145,
  value           : 'BIDIR'
});

newChanGrpDirection.on('select',function(e){
  if( e.getValue() == 'IN' ) {
    newChangGrpOutbound.disable();
    newChangGrpOutbound.getEl().up('.x-form-item').setDisplayed(false);
  } else {
    newChangGrpOutbound.enable();
    newChangGrpOutbound.getEl().up('.x-form-item').setDisplayed(true);
  }
});


var newChangGrpOutbound = new Ext.form.ComboBox({
  xtype           : 'combobox',
  name            : 'outboundHuntingScheme',
  fieldLabel      : "Outbound Hunting Scheme",
  helpText        : "outboundHuntingSchemeoutboundHuntingScheme",
  store           : ['LINEAR','REVERSE_LINEAR'],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  selectOnFocus   : true,
  width           : 145,
  minListWidth    : 145,
  value           : 'LINEAR'
});

var addChannelGroupForm = new Ext.FormPanel({
  id          : "addChannelGroupForm",
  region      : 'center',
  labelWidth  : 175,
  labelPad    : 10,
  bodyStyle   : 'padding:10px;',
  frame       : false,
  header      : false,
  footer      : false,
  buttonAlign : "right",
  buttons     : [{
    text: "Add",
    listeners: {'click':addChanGroup}
  },{
    text: "Cancel",
    listeners: {'click':function(){addChannelGroupWindow.hide();}}
  }]
});

addChannelGroupForm.add(newChanGrpID);
addChannelGroupForm.add(newChanGrpDirection);
addChannelGroupForm.add(newChangGrpOutbound);

var addChannelGroupWindow = new Ext.Window({
  id          : "addChannelGroupWindow",
  layout      : 'border',
  width       : 505,
  height      : 150,
  closeAction : 'hide',
  plain       : true
});

addChannelGroupWindow.add(addChannelGroupForm);

var gridChannelGroup = new Ext.grid.GridPanel({
  title:'Channel Group Grid',
  id:'gridChannelGroup',
  autoScroll:true,
  layout      : 'absolute',
  store: new Ext.data.JsonStore({
    id:'storeChannelGroup',
    url: 'config/getGridChannelGroupData',
    root: 'data',
    fields: [
      {name: 'id'},
      {name: 'direction'},
      {name: 'outboundHuntingScheme'},
      {name: 'nodeId'} //not displayed
    ]
  }),
  columns:[
    {header: "ID", width: 35, sortable: true, dataIndex: 'id', css:'padding:5px;'},
    {header: "Direction", width: 75, sortable: true, dataIndex: 'direction', css:'padding:5px;'},
    {header: "Outbound Hunting Scheme", width: 100, sortable: true, dataIndex: 'outboundHuntingScheme', css:'padding:5px;'}
  ],
  viewConfig:{forceFit:true}
});

gridChannelGroup.addButton("Add ChannelGroup",addChanGroupHandler,gridChannelGroup);
gridChannelGroup.addButton("Remove ChannelGroup",deleteChanGroupHandler,gridChannelGroup);

gridChannelGroup.on('rowdblclick', function(grid, rowIndex){
  var record = grid.store.getAt(rowIndex);
  goToNode(record.get('nodeId'));
});

//-----------------------------------------------
// Add/Delete ISDN configuration methods
//-----------------------------------------------
var addIsdnConfHandler = function(){
  addIsdnConfWindow.show();
};

function addIsdnConfig(){
  var form = addIsdnConfigForm.getForm();
  var el  = form.getEl();

  el.dom.action = "config/addIsdnConfig";
  el.dom.method = 'POST';
  var isdnConfig = Ext.util.JSON.encode(form.getValues());
  form.submit({
    params: {'isdnConfig':isdnConfig},
    success: function(){
      addIsdnConfWindow.hide();
      gridISDNConfiguration.store.reload();
      reloadTree(true);
    },
    failure: Paraxip.failureMessage
  });
};

var deleteIsdnConfHandler = function(){
  var selectedRecords = gridISDNConfiguration.getSelectionModel().getSelections();

  if (selectedRecords !== []) {
    if ((Paraxip.gridHasDigitalBoard(gridBoards) || Paraxip.gridHasVirtualDigitalBoard(gridBoards))
          && gridISDNConfiguration.store.getCount() - selectedRecords.length < 1 ){
      Ext.Msg.alert("Can not delete last configuration!",
        "At least one configuration is necessary for the system to work properly. " +
        "Please edit current configuration or create a new one before deleting " +
        "this one");
    } else {
      var isdnConfigs = new Array();
      for (var i = 0; i < selectedRecords.length; i++) {
        isdnConfigs.push(selectedRecords[i].data);
      }
      isdnConfigs = Ext.util.JSON.encode(isdnConfigs);
      Ext.Ajax.request({
        url: 'config/deleteIsdnConfig',
        method: 'POST',
        disableCaching: false,
        params: {"isdnConfigs":isdnConfigs},
        success: function ()
        {
          for (var index = 0; index < selectedRecords.length; index++) {
            gridISDNConfiguration.store.remove(selectedRecords[index]);
          }
          reloadTree(true);
        },
        failure: Paraxip.failureMessage
      });
    }
  }
};

var isdnConfigChoice = new Ext.form.ComboBox({
  id              : 'isdnConfigChoice',
  fieldLabel      : "ISDN Config Type",
  store           : ['FAS','NFAS'],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  value           : 'FAS',
  selectOnFocus   : true,
  width           : 100
});

var addIsdnConfigForm = new Ext.FormPanel({
  id          : "addIsdnConfigForm",
  region      : 'center',
  labelWidth  : 175,
  labelPad    : 10,
  bodyStyle   : 'padding:10px;',
  frame       : false,
  header      : false,
  footer      : false,
  buttonAlign : "right",
  buttons     : [{
    text: "Add",
    listeners: {'click':addIsdnConfig}
  },{
    text: "Cancel",
    listeners: {'click':function(){addIsdnConfWindow.hide();}}
  }]
});

addIsdnConfigForm.add(isdnConfigChoice);

var addIsdnConfWindow = new Ext.Window({
  id          : "addIsdnWindow",
  layout      : 'border',
  width       : 505,
  height      : 150,
  closeAction : 'hide',
  plain       : true
});

addIsdnConfWindow.add(addIsdnConfigForm);

var gridISDNConfiguration = new Ext.grid.GridPanel({
  title:'ISDN Configuration Grid',
  id:'gridISDNConfiguration',
  autoScroll:true,
  layout      : 'absolute',
  store: new Ext.data.JsonStore({
    id:'storeISDNConfiguration',
    url: 'config/getGridISDNConfigurationData',
    root: 'data',
    fields: [
      {name: 'id'},
      {name: 'displayName'},
      {name: 'nodeId'} //not displayed
    ]
  }),
  columns:[
    {header: "ID", width: 35, sortable: true, dataIndex: 'id', css:'padding:5px;'},
    {header: "Name", width: 200, sortable: true, dataIndex: 'displayName', css:'padding:5px;'}
  ],
  viewConfig:{forceFit:true}
});

gridISDNConfiguration.addButton("Add",addIsdnConfHandler,
                                gridISDNConfiguration);
gridISDNConfiguration.addButton("Delete",deleteIsdnConfHandler,
                                gridISDNConfiguration);

gridISDNConfiguration.on('rowdblclick', function(grid, rowIndex){
  var record = grid.store.getAt(rowIndex);
  goToNode(record.get('nodeId'));
});

//-----------------------------------------------
// Add/Delete Analog configuration methods
//-----------------------------------------------
var addAnalogConfHandler = function(){
  addAnalogConfWindow.show();
};

function addAnalogConfig(){
  var form = addAnalogConfigForm.getForm();
  var el  = form.getEl();

  el.dom.action = "config/addAnalogConfig";
  el.dom.method = 'POST';
  var analogConfig = Ext.util.JSON.encode(form.getValues());
  form.submit({
    params: {'analogConfig':analogConfig},
    success: function(){
      addAnalogConfWindow.hide();
      gridAnalogConfiguration.store.reload();
      reloadTree(true);
    },
    failure: Paraxip.failureMessage
  });
};

var deleteAnalogConfHandler = function(){
  var selectedRecords = gridAnalogConfiguration.getSelectionModel().getSelections();

  if (selectedRecords !== []) {
    if ( Paraxip.gridHasAnalogBoard(gridBoards) &&
          gridAnalogConfiguration.store.getCount() - selectedRecords.length < 1 ){
      Ext.Msg.alert("Can not delete last configuration!",
        "At least one configuration is necessary for the system to work properly. " +
        "Please edit current configuration or create a new one before deleting " +
        "this one");
    } else {
      var analogConfigs = new Array();
      for (var i = 0; i < selectedRecords.length; i++) {
        analogConfigs.push(selectedRecords[i].data);
      }
      analogConfigs = Ext.util.JSON.encode(analogConfigs);
      Ext.Ajax.request({
        url: 'config/deleteAnalogConfig',
        method: 'POST',
        disableCaching: false,
        params: {"analogConfigs":analogConfigs},
        success: function ()
        {
          for (var index = 0; index < selectedRecords.length; index++) {
            gridAnalogConfiguration.store.remove(selectedRecords[index]);
          }
          reloadTree(true);
        },
        failure: Paraxip.failureMessage
      });
    }
  }
};

var analogConfigChoice = new Ext.form.ComboBox({
  id              : 'analogConfigChoice',
  fieldLabel      : "Analog Config Type",
  store           : ['FXO'],// TODO add FXS
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  value           : 'FXO',
  selectOnFocus   : true,
  width           : 100
});

var addAnalogConfigForm = new Ext.FormPanel({
  id          : "addAnalogConfigForm",
  region      : 'center',
  labelWidth  : 175,
  labelPad    : 10,
  bodyStyle   : 'padding:10px;',
  frame       : false,
  header      : false,
  footer      : false,
  buttonAlign : "right",
  buttons     : [{
    text: "Add",
    listeners: {'click':addAnalogConfig}
  },{
    text: "Cancel",
    listeners: {'click':function(){addAnalogConfWindow.hide();}}
  }]
});

addAnalogConfigForm.add(analogConfigChoice);

var addAnalogConfWindow = new Ext.Window({
  id          : "addAnalogWindow",
  layout      : 'border',
  width       : 505,
  height      : 150,
  closeAction : 'hide',
  plain       : true
});

addAnalogConfWindow.add(addAnalogConfigForm);

var gridAnalogConfiguration = new Ext.grid.GridPanel({
  title:'Analog Configuration Grid',
  id:'gridAnalogConfiguration',
  autoScroll:true,
  layout      : 'absolute',
  store: new Ext.data.JsonStore({
    id:'storeAnalogConfiguration',
    url: 'config/getGridAnalogConfigurationData',
    root: 'data',
    fields: [
      {name: 'id'},
      {name: 'displayName'},
      {name: 'nodeId'} //not displayed
    ]
  }),
  columns:[
    {header: "ID", width: 35, sortable: true, dataIndex: 'id', css:'padding:5px;'},
    {header: "Name", width: 200, sortable: true, dataIndex: 'displayName', css:'padding:5px;'}
  ],
  viewConfig:{forceFit:true}
});

gridAnalogConfiguration.addButton("Add",addAnalogConfHandler,
                                  gridAnalogConfiguration);
gridAnalogConfiguration.addButton("Delete",deleteAnalogConfHandler,
                                  gridAnalogConfiguration);

gridAnalogConfiguration.on('rowdblclick', function(grid, rowIndex){
  var record = grid.store.getAt(rowIndex);
  goToNode(record.get('nodeId'));
});

/*
 * This method is used to show/hide the gainIndB field of the Physical Config
 * forms according to the LevelControl/Mode attribute. If mode is automatic,
 * hide the field; if it's true, show the field.
 */

function isNumberofRingsVisible(){
  var notifyOutCond = notifyOutbound_condition_select;
  var numberOfRings = numOfRings_text;
  if( notifyOutCond.getValue() == "AFTER-N-RING") {
      numberOfRings.enable();
  } else {
    numberOfRings.disable();
    numberOfRings.clearInvalid();
  }
};

//------------------------------------------------
// Factory to create common fields between forms
//------------------------------------------------

function createIdText(config){
  return new Ext.form.TextField(Ext.apply({
    fieldLabel  : "ID",
    name        : "id",
    width       : 162,
    disabled    : true
  }, config));
};

function createNameText(config){
  return new Ext.form.TextField(Ext.apply({
    fieldLabel  : "Display Name",
    name        : "displayName",
    width       : 162
  }, config));
};

function createIsdnTerminationSelection(config){
  return new Ext.form.ComboBox( Ext.apply({
    name            : 'termination',
    fieldLabel      : "Termination",
    helpText        : "isdnCommonParameterstermination",
    store           : ['NETWORK','TERMINAL'],
    forceSelection  : true,
    triggerAction   : 'all',
    mode            : 'local',
    typeAhead       : true,
    selectOnFocus   : true,
    width           : 145,
    minListWidth    : 145
  }, config));
};

function createIsdnSwitchVariantSelection(config){
  return new Ext.form.ComboBox( Ext.apply({
    name            : 'switchVariant',
    fieldLabel      : "Switch Variant",
    helpText        : "isdnCommonParametersswitchVariant",
    store           : ['ETSI','EuroISDN','DMS100','5ESS','NI2'],
    forceSelection  : true,
    triggerAction   : 'all',
    mode            : 'local',
    typeAhead       : true,
    selectOnFocus   : true,
    width           : 145,
    minListWidth    : 145
  }, config));
};

function createIsdnBChannelNegotiationSelection(config){
  return new Ext.form.ComboBox( Ext.apply({
    name            : 'BChannelNegotiation',
    fieldLabel      : "B-Channel Negotiation",
    helpText        : "isdnCommonParametersBChannelNegotiation",
    store           : ['PREFERRED','EXCLUSIVE'],
    forceSelection  : true,
    triggerAction   : 'all',
    mode            : 'local',
    typeAhead       : true,
    selectOnFocus   : true,
    width           : 145,
    minListWidth    : 145
  }, config));
};

function createIsdnInitRestartProcSelection(config){
  return new Ext.form.ComboBox( Ext.apply({
    name            : 'initiateRestartProcedure',
    fieldLabel      : "Initiate Restart Procedure",
    helpText        : "isdnCommonParametersinitiateRestartProcedure",
    store           : ['YES','NO'],
    forceSelection  : true,
    triggerAction   : 'all',
    mode            : 'local',
    typeAhead       : true,
    selectOnFocus   : true,
    width           : 145,
    minListWidth    : 145
  }, config));
};


function createIsdnInProgTonesGenSelection(config){
  return new Ext.form.ComboBox( Ext.apply({
    name            : 'inbandProgressTonesGeneration',
    fieldLabel      : "Inband Progress Tones Generation",
    helpText        : "isdnCommonParametersinbandProgressTonesGeneration",
    store           : ['NEVER','ALWAYS','AS-NEEDED'],
    forceSelection  : true,
    triggerAction   : 'all',
    mode            : 'local',
    typeAhead       : true,
    selectOnFocus   : true,
    width           : 145,
    minListWidth    : 145
  }, config));
};


function createIsdnInProgTonesIndSelection(config){
  return new Ext.form.ComboBox( Ext.apply({
    name            : 'inbandProgressTonesIndicator',
    fieldLabel      : "Inband Progress Tones Indicator",
    helpText        : "isdnCommonParametersinbandProgressTonesIndicator",
    store           : ['ALERTING','PROGRESS','BOTH'],
    forceSelection  : true,
    triggerAction   : 'all',
    mode            : 'local',
    typeAhead       : true,
    selectOnFocus   : true,
    width           : 145,
    minListWidth    : 145
  }, config));
};

//------------------------------------------------
//  Common methods
//------------------------------------------------

function callControlCancel(){
  reloadTree(true);
};

//------------------------------------------------
// Channel Group form
// -----------------------------------------------
function saveChannelGroup(e){
  var owner = e.ownerCt;
  var form = owner.getForm();
  var el = form.getEl();

  el.dom.action = 'config/saveChannelGroup';
  el.dom.method = 'POST';

  var channelGroup = Ext.util.JSON.encode(form.getValues());

  form.submit({
    params:{
      'channelGroup': channelGroup
    },
    success: function(){
      reloadTree(true);
    },
    failure: Paraxip.failureMessage
  });

};

function showOutboundScheme(){
  if( direction_select.getValue() == "IN" ) {
    outboundHuntingScheme_select.disable();
    outboundHuntingScheme_select.getEl().up('.x-form-item').setDisplayed(false);
  } else {
    outboundHuntingScheme_select.enable();
    outboundHuntingScheme_select.getEl().up('.x-form-item').setDisplayed(true);
  }
};

var frmChannelGroup = new Ext.FormPanel({
  title           : "Digital Physical Configuration",
  frame           : true,
  header          : false,
  id              : "frmChannelGroup",
  autoScroll      : true,
  layout        : 'accordion',
  layoutConfig  : {
    activeItem  : 0
  },
  defaults    : {
    layout: 'form',
    style: 'text-align:left;',
    labelWidth: 150,
    bodyStyle: 'padding:5px;',
    width: 500,
    autoHeight: true,
    fill: true
  },
  buttonAlign     : "right",
  buttons         : [{
    text: 'Save',
    listeners: {'click':saveChannelGroup}
  },{
    text: 'Cancel',
    listeners: {'click':callControlCancel}
  }]
});

var id_textChanGroup = new Ext.form.TextField({
  id          : 'id_textChanGroup',
  fieldLabel  : "ID",
  name        : "id",
  helpText    : "channelGroupIDID",
  width       : 162,
  disabled    : true
});

var direction_select = new Ext.form.ComboBox({
  id              : 'direction_selection',
  name            : 'direction',
  fieldLabel      : "Direction",
  store           : ['IN','OUT', 'BIDIR'],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  selectOnFocus   : true,
  width           : 145,
  minListWidth    : 145
});

direction_select.on('select',function(e){
  if( e.getValue() == 'IN' ) {
    outboundHuntingScheme_select.disable();
    outboundHuntingScheme_select.getEl().up('.x-form-item').setDisplayed(false);
  } else {
    outboundHuntingScheme_select.enable();
    outboundHuntingScheme_select.getEl().up('.x-form-item').setDisplayed(true);
  }
});


var outboundHuntingScheme_select = new Ext.form.ComboBox({
  id              : 'outboundHuntingScheme_selection',
  name            : 'outboundHuntingScheme',
  fieldLabel      : "Outbound Hunting Scheme",
  helpText        : "outboundHuntingSchemeoutboundHuntingScheme",
  store           : ['LINEAR','REVERSE_LINEAR'],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  selectOnFocus   : true,
  width           : 145,
  minListWidth    : 145
});

var ChannelGroupPanel = new Ext.Panel({
  id    : 'ChannelGroupPanel',
  name  : 'channelGroup',
  title : 'Channel Group',
  items : [{
    xtype: 'textfield',
    name: 'nodeId',
    hidden: true,
    hideLabel: true
  }]
});

ChannelGroupPanel.add(id_textChanGroup);
ChannelGroupPanel.add(direction_select);
ChannelGroupPanel.add(outboundHuntingScheme_select);
frmChannelGroup.add(ChannelGroupPanel);

//------------------------------------------------
// ISDN FAS config form
// -----------------------------------------------
function saveFasConfig(e){
  var owner = e.ownerCt;
  var form = owner.getForm();
  var el = form.getEl();

  el.dom.action = 'config/saveFasConfig';
  el.dom.method = 'POST';

  var fasConfig = Ext.util.JSON.encode(form.getValues());

  form.submit({
    params:{
      'fasConfig': fasConfig
    },
    success: function(){
      reloadTree(true);
    },
    failure: Paraxip.failureMessage
  });

};

//Common to Fas and Nfas
function applyToFas(e){
  var grid = e.ownerCt;
  var url;
  var params;
  var gridData;
  var records;
  var i;

  if( grid.getItemId() == "fasBChannelGrid") {
    url = "config/applyBChannelToFasConfig";
    records = grid.getStore().getRange();
    gridData = new Array();
    for (i = 0; i < records.length; i++) {
      gridData.push(records[i].data);
    }
    gridData = Ext.util.JSON.encode(gridData);
    params = {'gridData':gridData,'fasConfigID':Ext.util.JSON.encode(fasID)};
  } else if( grid.id == "nfasBChannelGrid") {
    url = "config/applyBChannelToNfasConfig";
    records = grid.getStore().getRange();
    gridData = new Array();
    for (i = 0; i < records.length; i++) {
      gridData.push(records[i].data);
    }
    gridData = Ext.util.JSON.encode(gridData);
    params = {'gridData':gridData,'nfasGroupID':Ext.util.JSON.encode(nfasID)};
  }

  Ext.Ajax.request({
    url: url,
    method: 'POST',
    disableCaching: false,
    params: params,
    success: function(){
      grid.ownerCt.hide();
      //reloadTree(true);
    },
    failure: Paraxip.failureMessage
  });

};

function addBchannel(e){
  var form = e.ownerCt;
  var values = form.getForm().getValues(false);

  if( form.getForm().isValid() ) {
    if( form.id == 'addBChannelFasForm') {
      var newRecord = new DataRecord({
        'boardId':values['boardId'],
        'interfaceId':values['interfaceId'],
        'firstChannel':values['firstChannel'],
        'lastChannel':values['lastChannel'],
        'channelGroupID':values['channelGroupID']
      });
      fasBChannelGrid.getStore().add(newRecord);
      fasBChannelGrid.expand();
    } else if( form.id == 'addBChannelNfasForm' ) {
      var newRecord = new DataRecord({
        'boardId':values['boardId'],
        'interfaceId':values['interfaceId'],
        'nfasInterfaceID':values['nfasInterfaceID'],
        'DChannelMode':values['DChannelMode'],
        'firstChannel':values['firstChannel'],
        'lastChannel':values['lastChannel'],
        'channelGroupID':values['channelGroupID']
      });
      nfasBChannelGrid.getStore().add(newRecord);
      nfasBChannelGrid.expand();
    }
  }
};

//Common to Fas and Nfas
function deleteBchannels(e){
  var grid = e.ownerCt;

  var selectedRecords = grid.getSelectionModel().getSelections();

  if (selectedRecords !== []) {
    for( i = 0; i < selectedRecords.length; i++ ) {
      grid.getStore().remove(selectedRecords[i]);
    }
  }

};

var storeFasBoards = new Ext.data.JsonStore({
    id:'storeFasBoards',
    url: 'config/getBoards',
    root: 'data',
    fields: ['id','displayName','nodeId']
});

var storeFasInterfaces = new Ext.data.JsonStore({
    id:'storeFasInterfaces',
    url: 'config/getInterfaces',
    root: 'data',
    fields: ['id','displayName']
});

var storeFasChannelGroup = new Ext.data.JsonStore({
    id:'storeFasChannelGroup',
    url: 'config/getChannelGroups',
    root: 'data',
    fields: ['id']
});

var assignedBChannelFasWindow = new Ext.Window({
  title       : 'Assign BChannel to Fas Config',
  layout      : 'accordion',
  layoutConfig : {
     autoWidth:false
  },
  width       : 600,
  height      : 500,
  closeAction : 'hide',
  resizable   : false,
  plain       : true,
  defaults    : {
    collapsed : true
  },
  id          : "assignedBChannelFasWindow"
});

var fasBChannelGrid = new Ext.grid.EditorGridPanel({
  title       : 'BChannels assigned to config',
  id          : 'fasBChannelGrid',
  autoScroll  : true,
  width       : 500,
  height      : 400,
  clicksToEdit: 2,
  enableColumnMove : false,
  selModel    : new Ext.grid.RowSelectionModel(),
  store       : new Ext.data.JsonStore({
    id:'storeFasBChannelGrid',
    url: 'config/getFasBChannels',
    root: 'data',
    fields: [
      {name: 'boardId'},
      {name: 'interfaceId'},
      {name: 'firstChannel'},
      {name: 'lastChannel'},
      {name: 'channelGroupID'},
      {name: 'nodeId'} //not displayed
    ]
  }),
  columns     :[
    {
      header: "Board ID",
      width: 110,
      sortable: true,
      dataIndex: 'boardId',
      editor: new Ext.form.ComboBox({
        forceSelection  : true,
        triggerAction   : 'all',
        mode            : 'local',
        selectOnFocus   : true,
        valueField      : 'id',
        displayField    : 'id',
        store           : storeFasBoards,
        listClass       : 'x-combo-list-small'
      })
    },
    {
      header: "Interface ID",
      width: 110,
      sortable: true,
      dataIndex: 'interfaceId',
//    editor: new Ext.form.NumberField({
//      allowNegative : false,
//      allowBlank  : false
//    })
      editor: new Ext.form.ComboBox({
        forceSelection  : true,
        triggerAction   : 'all',
        mode            : 'local',
        selectOnFocus   : true,
        valueField      : 'id',
        displayField    : 'id',
        store           : storeFasInterfaces,
        listClass       : 'x-combo-list-small'
      })
    },
    {
      header: "First Channel",
      width: 110,
      sortable: true,
      dataIndex: 'firstChannel',
      editor: new Ext.form.NumberField({
        allowNegative : false,
        allowBlank  : false
      })
    },
    {
      header: "Last Channel",
      width: 110,
      sortable: true,
      dataIndex: 'lastChannel',
      editor: new Ext.form.NumberField({
        allowNegative : false,
        allowBlank  : false
      })
    },
    {
      header: "Channel Group ID",
      width: 110,
      sortable: true,
      dataIndex: 'channelGroupID',
      editor: new Ext.form.ComboBox({
        forceSelection  : true,
        triggerAction   : 'all',
        mode            : 'local',
        selectOnFocus   : true,
        valueField      : 'id',
        displayField    : 'id',
        store           : storeFasChannelGroup,
        listClass       : 'x-combo-list-small'
      })
    }
  ],
  listeners       : {
    'afteredit':function(e){
      if( e.field == "boardId" ) {
        var colModel = e.grid.getColumnModel();
        var newColumn = e.column + 1;
        var cellEditor = colModel.getCellEditor(newColumn,e.row);
        cellEditor.field.store.load({
          url: 'config/getInterfaces',
          disableCaching: false,
          params: {'id':e.value}
        });
      }
    }
  },
  viewConfig:{forceFit:true}
});

fasBChannelGrid.store.on('load',function(store){
  store.each(function(record,index){
         var colModel = fasBChannelGrid.getColumnModel();
//  var columnIndex = colModel.getIndexById('interfaceId');
    colModel.getCellEditor(1,index).field.store.load({
      url: 'config/getInterfaces',
      disableCaching: false,
      params: {'id':record.data['boardId']}
    });
  });
});

fasBChannelGrid.addButton("Delete",deleteBchannels,fasBChannelGrid);
fasBChannelGrid.addButton("Save",applyToFas,fasBChannelGrid);
fasBChannelGrid.addButton("Cancel",function(){assignedBChannelFasWindow.hide();});

var addBChannelFasForm = new Ext.FormPanel({
  id          : "addBChannelFasForm",
  title       : "Add BChannel",
  bodyStyle   : "padding:10px;",
  buttonAlign : 'right',
  labelWidth  : 130,
  buttons     : [{
    text: "Add",
    listeners: {'click':addBchannel}
  }]
 });

var fasBoardsBox = new Ext.form.ComboBox({
  id              : "fasBoardsBox",
  name            : 'boardId',
  fieldLabel      : "Board ID",
  allowBlank      : false,
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  selectOnFocus   : true,
  valueField      : 'id',
  displayField    : 'id',
  //minListWidth    : 165,
  store           : storeFasBoards
});

fasBoardsBox.on('select',function(e,record){
  fasInterfaceBox.clearValue();
  fasInterfaceBox.store.load({
    url: 'config/getInterfaces',
    disableCaching: false,
    params: {'id':record.data['id']}
  });
});

var fasInterfaceBox = new Ext.form.ComboBox({
  id              : "fasInterfaceBox",
  name            : 'interfaceId',
  fieldLabel      : "Interface ID",
  helpText        : "fasConfigPatternfasConfigID",
  allowBlank      : false,
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  selectOnFocus   : true,
  valueField      : 'id',
  displayField    : 'id',
  minListWidth    : 145,
  store           : storeFasInterfaces
});

var fasFirstChan = new Ext.form.NumberField({
  id          : 'fasFirstChan',
  name        : 'firstChannel',
  fieldLabel  : 'First BChannel',
  //helpText    : 'BChannelRangePatternBChannelRangefirstChannel',
  // JN: I took the liberty to put this definition which is more verbose
  helpText    : 'BChannelRangePatternBChannelRange',
  allowNegative : false,
  allowBlank  : false
});

var fasLastChan = new Ext.form.NumberField({
  id          : 'fasLastChan',
  name        : 'lastChannel',
  fieldLabel  : 'Last BChannel',
  helpText    : 'BChannelRangePatternBChannelRangelastChannel',
  allowNegative : false,
  allowBlank  : false
});

var fasChanGroupBox = new Ext.form.ComboBox({
  id              : "fasChanGroupBox",
  name            : 'channelGroupID',
  allowBlank      : false,
  fieldLabel      : "Channel Group ID",
  helpText        : 'BChannelRangePatternBChannelRangechannelGroupID',
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  selectOnFocus   : true,
  valueField      : 'id',
  displayField    : 'id',
  minListWidth    : 145,
  store           : storeFasChannelGroup
});

addBChannelFasForm.add(fasBoardsBox);
addBChannelFasForm.add(fasInterfaceBox);
addBChannelFasForm.add(fasFirstChan);
addBChannelFasForm.add(fasLastChan);
addBChannelFasForm.add(fasChanGroupBox);

assignedBChannelFasWindow.add(fasBChannelGrid);
assignedBChannelFasWindow.add(addBChannelFasForm);

var fasID = '';

var frmIsdnFas = new Ext.FormPanel({
  title           : "ISDN FAS config",
  frame           : true,
  header          : false,
  id              : "frmIsdnFas",
  autoScroll      : true,
  layout        : 'accordion',
  layoutConfig  : {
    activeItem  : 0
  },
  defaults    : {
    layout: 'form',
    style: 'text-align:left;',
    labelWidth: 150,
    bodyStyle: 'padding:5px;',
    width: 500,
    autoHeight: true,
    fill: true
  },
  buttonAlign     : "right",
  buttons         : [{
    text: 'Assigned BChannel(s)',
    listeners: {
      'click':function(){
        fasID = idFas_text.getValue();
        fasBoardsBox.setValue('');
        fasInterfaceBox.setValue('');
        fasChanGroupBox.setValue('');
        fasBChannelGrid.getStore().load({
          url: 'config/getFasBChannels',
          params: {'id':fasID}
        });
        fasBoardsBox.store.load({
          url: 'config/getBoards',
          params: {'id':fasID}
        });
        fasChanGroupBox.store.load({
          url: 'config/getChannelGroups',
          params: {'id':fasID}
        });
        assignedBChannelFasWindow.show();
      }
    }
  },{
    text: 'Save',
    listeners: {'click':saveFasConfig}
  },{
    text: 'Cancel',
    listeners: {'click':callControlCancel}
  }]
});

var idFas_text = createIdText({
  id  : 'idFas_text'
});

var nameFas_text = createNameText({
  id  : 'nameFas_text'
});

var terminationFas_select = createIsdnTerminationSelection({
  id  : 'terminationFas_select'
});

var switchVariantFas_select = createIsdnSwitchVariantSelection({
  id  : 'switchVariantFas_select'
});

var BChannelNegotiationFas_select =
                            createIsdnBChannelNegotiationSelection({
  id  : 'BChannelNegotiationFas_select'
});

var initRestartProcFas_select = createIsdnInitRestartProcSelection({
  id  : 'initRestartProcFas_select'
});

var inbandProgTonesGenFas_select = createIsdnInProgTonesGenSelection({
  id  : 'inbandProgTonesGenFas_select'
});

var inbandProgTonesIndFas_select = createIsdnInProgTonesIndSelection({
  id  : 'inbandProgTonesIndFas_select'
});

var FasPanel = new Ext.Panel({
  id    : 'FasPanel',
  name  : 'fas',
  title : 'Fas Configuration',
  items : [{
    xtype: 'textfield',
    name: 'nodeId',
    hidden: true,
    hideLabel: true
  }]
});

FasPanel.add(idFas_text);
FasPanel.add(nameFas_text);
FasPanel.add(terminationFas_select);
FasPanel.add(switchVariantFas_select);
FasPanel.add(BChannelNegotiationFas_select);
FasPanel.add(initRestartProcFas_select);
FasPanel.add(inbandProgTonesGenFas_select);
FasPanel.add(inbandProgTonesIndFas_select);
frmIsdnFas.add(FasPanel);

/* JN TODO : applyToFasConfig  */


//------------------------------------------------
// ISDN NFAS config form
// -----------------------------------------------

var storeNfasBoards = new Ext.data.JsonStore({
    id:'storeNfasBoards',
    url: 'config/getBoards',
    root: 'data',
    fields: ['id','displayName','nodeId']
});

var storeNfasInterfaces = new Ext.data.JsonStore({
    id:'storeNfasInterfaces',
    url: 'config/getInterfaces',
    root: 'data',
    fields: ['id','displayName']
});

var storeNfasChannelGroup = new Ext.data.JsonStore({
    id:'storeNfasChannelGroup',
    url: 'config/getChannelGroups',
    root: 'data',
    fields: ['id']
});

var storeDchannelMode = ['DISABLED','PRIMARY','BACKUP'];

var assignedBChannelNfasWindow = new Ext.Window({
  title       : 'Assign BChannel to Nfas Group',
  layout      : 'accordion',
  width       : 600,
  layoutConfig : {
    autoWidth:false
  },
  height      : 500,
  closeAction : 'hide',
  resizable   : false,
  plain       : true,
  id          : "assignedBChannelNfasWindow"
});

var nfasBChannelGrid = new Ext.grid.EditorGridPanel({
  title       : 'BChannels assigned to config',
  id          : 'nfasBChannelGrid',
  autoScroll  : true,
  width       : 500,
  height      : 400,
  clicksToEdit: 2,
  enableColumnMove : false,
  selModel    : new Ext.grid.RowSelectionModel(),
  store       : new Ext.data.JsonStore({
    id:'storeNfasBChannelGrid',
    url: 'config/getNfasBChannels',
    root: 'data',
    fields: [
      {name: 'boardId'},
      {name: 'interfaceId'},
      {name: 'nfasInterfaceID'},
      {name: 'DChannelMode'},
      {name: 'firstChannel'},
      {name: 'lastChannel'},
      {name: 'channelGroupID'},
      {name: 'nodeId'} //not displayed
    ]
  }),
  columns     :[
    {
      header: "Board ID",
      width: 95,
      sortable: true,
      dataIndex: 'boardId',
      editor: new Ext.form.ComboBox({
        forceSelection  : true,
        triggerAction   : 'all',
        mode            : 'local',
        selectOnFocus   : true,
        valueField      : 'id',
        displayField    : 'id',
        store           : storeNfasBoards,
        listClass       : 'x-combo-list-small'
      })
    },
    {
      header: "Interface ID",
      width: 95,
      sortable: true,
      dataIndex: 'interfaceId',
//    editor: new Ext.form.NumberField({
//      allowNegative  : false,
//      allowBlank  : false
//    })
      editor: new Ext.form.ComboBox({
        forceSelection  : true,
        triggerAction   : 'all',
        mode            : 'local',
        selectOnFocus   : true,
        valueField      : 'id',
        displayField    : 'id',
        store           : storeNfasInterfaces,
        listClass       : 'x-combo-list-small'
      })
    },
    {
      header: "NFasInterface ID",
      width: 115,
      sortable: true,
      dataIndex: 'nfasInterfaceID',
      editor: new Ext.form.NumberField({
        allowNegative  : false,
        allowBlank  : false
      })
    },
    {
      header: "DChannel Mode",
      width: 110,
      sortable: true,
      dataIndex: 'DChannelMode',
      editor: new Ext.form.ComboBox({
        forceSelection  : true,
        triggerAction   : 'all',
        mode            : 'local',
        selectOnFocus   : true,
        store           : storeDchannelMode,
        listClass       : 'x-combo-list-small'
      })
    },
    {
      header: "First Channel",
      width: 100,
      sortable: true,
      dataIndex: 'firstChannel',
      editor: new Ext.form.NumberField({
        allowNegative  : false,
        allowBlank  : false
      })
    },
    {
      header: "Last Channel",
      width: 100,
      sortable: true,
      dataIndex: 'lastChannel',
      editor: new Ext.form.NumberField({
        allowNegative  : false,
        allowBlank  : false
      })
    },
    {
      header: "Channel Group ID",
      width: 105,
      sortable: true,
      dataIndex: 'channelGroupID',
      editor: new Ext.form.ComboBox({
        forceSelection  : true,
        triggerAction   : 'all',
        mode            : 'local',
        selectOnFocus   : true,
        valueField      : 'id',
        displayField    : 'id',
        store           : storeNfasChannelGroup,
        listClass       : 'x-combo-list-small'
      })
    }
  ],
  listeners       : {
    'afteredit':function(e){
      if( e.field == "boardId" ) {
        var colModel = e.grid.getColumnModel();
        var newColumn = e.column+1;
        var cellEditor = colModel.getCellEditor(newColumn,e.row);
        cellEditor.field.store.load({
          url: 'config/getInterfaces',
          disableCaching: false,
          params: {'id':e.value}
        });
      }
    }
  },
  viewConfig:{forceFit:true}
});

nfasBChannelGrid.store.on('load',function(store){
  store.each(function(record,index){
         var colModel = nfasBChannelGrid.getColumnModel();
//  var columnIndex = colModel.getIndexById('interfaceId');
    colModel.getCellEditor(1,index).field.store.load({
      url: 'config/getInterfaces',
      disableCaching: false,
      params: {'id':record.data['boardId']}
    });
  });
});

nfasBChannelGrid.addButton("Delete",deleteBchannels,nfasBChannelGrid);
nfasBChannelGrid.addButton("Save",applyToFas,nfasBChannelGrid);
nfasBChannelGrid.addButton("Cancel",function(){assignedBChannelNfasWindow.hide();});

var addBChannelNfasForm = new Ext.FormPanel({
  id          : "addBChannelNfasForm",
  title       : "Add BChannel",
  labelWidth  : 130,
  bodyStyle   : "padding:10px;",
  buttonAlign : "right",
  buttons     : [{
    text: "Add",
    listeners: {'click':addBchannel}
  }]
 });

var nfasBoardsBox = new Ext.form.ComboBox({
  id              : "nfasBoardsBox",
  name            : 'boardId',
  fieldLabel      : "Board ID",
  allowBlank      : false,
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  selectOnFocus   : true,
  valueField      : 'id',
  displayField    : 'id',
  minListWidth    : 145,
  store           : storeNfasBoards
});

nfasBoardsBox.on('select',function(e,record){
  nfasInterfaceBox.clearValue();
  nfasInterfaceBox.store.load({
    url: 'config/getInterfaces',
    disableCaching: false,
    params: {'id':record.data['id']}
  });
});

var nfasInterfaceBox = new Ext.form.ComboBox({
  id              : "nfasInterfaceBox",
  name            : 'interfaceId',
  fieldLabel      : "Interface ID",
  allowBlank      : false,
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  selectOnFocus   : true,
  valueField      : 'id',
  displayField    : 'id',
  minListWidth    : 145,
  store           : storeNfasInterfaces
});

var nfasInterfaceID = new Ext.form.NumberField({
  id          : 'nfasInterfaceID',
  name        : 'nfasInterfaceID',
  fieldLabel  : 'NFAS Interface ID',
  allowNegative : false,
  allowBlank  : false
});

var nfasDChannelModeBox = new Ext.form.ComboBox({
  id              : "nfasDChannelModeBox",
  name            : "DChannelMode",
  fieldLabel      : "DChannel Mode",
  allowBlank      : false,
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  selectOnFocus   : true,
  valueField      : 'mode',
  displayField    : 'mode',
  minListWidth    : 145,
  store           : storeDchannelMode
});

var nfasFirstChan = new Ext.form.NumberField({
  id          : 'nfasFirstChan',
  name        : 'firstChannel',
  fieldLabel  : 'First BChannel',
  allowNegative : false,
  allowBlank  : false
});

var nfasLastChan = new Ext.form.NumberField({
  id          : 'nfasLastChan',
  name        : 'lastChannel',
  fieldLabel  : 'Last BChannel',
  allowNegative : false,
  allowBlank  : false
});

var nfasChanGroupBox = new Ext.form.ComboBox({
  id              : "nfasChanGroupBox",
  name            : 'channelGroupID',
  allowBlank      : false,
  fieldLabel      : "Channel Group ID",
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  selectOnFocus   : true,
  valueField      : 'id',
  displayField    : 'id',
  minListWidth    : 145,
  store           : storeNfasChannelGroup
});

addBChannelNfasForm.add(nfasBoardsBox);
addBChannelNfasForm.add(nfasInterfaceBox);
addBChannelNfasForm.add(nfasInterfaceID);
addBChannelNfasForm.add(nfasDChannelModeBox);
addBChannelNfasForm.add(nfasFirstChan);
addBChannelNfasForm.add(nfasLastChan);
addBChannelNfasForm.add(nfasChanGroupBox);

assignedBChannelNfasWindow.add(nfasBChannelGrid);
assignedBChannelNfasWindow.add(addBChannelNfasForm);

var nfasID = '';

function saveNfasConfig(e){
  var owner = e.ownerCt;
  var form = owner.getForm();
  var el = form.getEl();

  el.dom.action = 'config/saveNfasConfig';
  el.dom.method = 'POST';

  var nfasGroup = Ext.util.JSON.encode(form.getValues());

  form.submit({
    params:{
      'nfasGroup': nfasGroup
    },
    success: function(){
      reloadTree(true);
    },
    failure: Paraxip.failureMessage
  });

};

var frmIsdnNfas = new Ext.FormPanel({
  title           : "ISDN NFAS config",
  frame           : true,
  header          : false,
  id              : "frmIsdnNfas",
  autoScroll      : true,
  layout        : 'accordion',
  layoutConfig  : {
    activeItem  : 0
  },
  defaults    : {
    layout: 'form',
    style: 'text-align:left;',
    labelWidth: 150,
    bodyStyle: 'padding:5px;',
    width: 500,
    autoHeight: true,
    fill: true
  },
  buttonAlign     : "right",
  buttons         : [{
    text: 'Assigned BChannel(s)',
    listeners: {
      'click':function(){
        nfasID = idNfas_text.getValue();
        nfasBoardsBox.setValue('');
        nfasInterfaceBox.setValue('');
        nfasChanGroupBox.setValue('');
        nfasBChannelGrid.getStore().load({
          url: 'config/getNfasBChannels',
          params: {'id':nfasID}
        });
        nfasBoardsBox.store.load({
          url: 'config/getBoards',
          params: {'id':nfasID}
        });
        nfasChanGroupBox.store.load({
          url: 'config/getChannelGroups',
          params: {'id':nfasID}
        });
        assignedBChannelNfasWindow.show();
      }
    }
  },{
    text: 'Save',
    listeners: {'click':saveNfasConfig}
  },{
    text: 'Cancel',
    listeners: {'click':callControlCancel}
  }]
});

var NfasPanel = new Ext.Panel({
  id    : 'NfasPanel',
  name  : 'nfas',
  title : 'Nfas Configuration',
  items : [{
    xtype: 'textfield',
    name: 'nodeId',
    hidden: true,
    hideLabel: true
  }]
});

var idNfas_text = createIdText({
  id  : 'idNfas_text'
});

var nameNfas_text = createNameText({
  id  : 'nameNfas_text'
});

var terminationNfas_select = createIsdnTerminationSelection({
  id  : 'terminationNfas_select'
});

var switchVariantNfas_select = createIsdnSwitchVariantSelection({
  id  : 'switchVariantNfas_select'
});

var BChannelNegotiationNfas_select =
                            createIsdnBChannelNegotiationSelection({
  id  : 'BChannelNegotiationNfas_select'
});

var initRestartProcNfas_select = createIsdnInitRestartProcSelection({
  id  : 'initRestartProcNfas_select'
});

var inbandProgTonesGenNfas_select = createIsdnInProgTonesGenSelection({
  id  : 'inbandProgTonesGenNfas_select'
});

var inbandProgTonesIndNfas_select = createIsdnInProgTonesIndSelection({
  id  : 'inbandProgTonesIndNfas_select'
});

NfasPanel.add(idNfas_text);
NfasPanel.add(nameNfas_text);
NfasPanel.add(terminationNfas_select);
NfasPanel.add(switchVariantNfas_select);
NfasPanel.add(BChannelNegotiationNfas_select);
NfasPanel.add(initRestartProcNfas_select);
NfasPanel.add(inbandProgTonesGenNfas_select);
NfasPanel.add(inbandProgTonesIndNfas_select);
frmIsdnNfas.add(NfasPanel);

/*
// Analog Fxo Detector
*/
function addDetectorHandler(){
  addDetectorWindow.show();
};

function addDetector(){
  var form = addDetectorForm.getForm();
  var el  = form.getEl();

  el.dom.action = "config/addDetector";
  el.dom.method = 'POST';
  var Detector = Ext.util.JSON.encode(form.getValues());
  form.submit({
    params: {'detector':detector},
    success: function(){
      addDetectorWindow.hide();
      gridDetector.store.reload();
      reloadTree(true);
    },
    failure: Paraxip.failureMessage
  });
};

function deleteDetectorHandler(){
  var selectedRecords = gridDetector.getSelectionModel().getSelections();

  if (selectedRecords !== []) {
    if ( gridDetector.store.getCount() - selectedRecords.length < 1 ){
      Ext.Msg.alert("Can not delete last Detector!",
        "At least one Detector is necessary for the system to work properly. " +
        "Please edit current config or create a new one before deleting " +
        "this one");
    } else {
      var detectors = new Array();
      for (var i = 0; i < selectedRecords.length; i++) {
        detectors.push(selectedRecords[i].data);
      }
      detectors = Ext.util.JSON.encode(detectors);
      Ext.Ajax.request({
        url: 'config/deleteDetector',
        method: 'POST',
        disableCaching: false,
        params: {"detectors":detectors},
        success: function ()
        {
          for (var index = 0; index < selectedRecords.length; index++) {
            gridDetector.store.remove(selectedRecords[index]);
          }
          reloadTree(true);
        },
        failure: Paraxip.failureMessage
      });
    }
  }
};
var newDetectorName = new Ext.form.TextField({
  xtype       : 'textfield',
  fieldLabel  : "Name",
  name        : "name",
  width       : 145 ,
  allowBlank  : false
});

var newDetectorSequence = new Ext.form.TextField({
  xtype       : 'textfield',
  fieldLabel  : "Sequence",
  name        : "sequence",
  helpText    : "disconnectSupervisionParametersdisconnectSupervisiondisconnectDetectorsdetector",
  width       : 145 ,
  allowBlank  : false
});

var addDetectorForm = new Ext.FormPanel({
  id          : "addDetectorForm",
  region      : 'center',
  labelWidth  : 175,
  labelPad    : 10,
  bodyStyle   : 'padding:10px;',
  frame       : false,
  header      : false,
  footer      : false,
  buttonAlign : "right",
  buttons     : [{
    text: "Add",
    listeners: {'click':addDetector}
  },{
    text: "Cancel",
    listeners: {'click':function(){addDetectorWindow.hide();}}
  }]
});

addDetectorForm.add(newDetectorName);
addDetectorForm.add(newDetectorSequence);

var addDetectorWindow = new Ext.Window({
  id          : "addDetectorWindow",
  layout      : 'border',
  width       : 505,
  height      : 150,
  closeAction : 'hide',
  plain       : true
});

addDetectorWindow.add(addDetectorForm);

var gridDetector = new Ext.grid.GridPanel({
  title:'Channel Group Grid',
  id:'gridDetector',
  autoScroll:true,
  store: new Ext.data.JsonStore({
    id:'storeDetector',
    url: 'config/getGridDetectorData',
    root: 'data',
    fields: [
      {name: 'id'},
      {name: 'direction'},
      {name: 'outboundHuntingScheme'},
      {name: 'nodeId'} //not displayed
    ]
  }),
  columns:[
    {header: "Name", width: 35, sortable: true, dataIndex: 'name', css:'padding:5px;'},
    {header: "Sequence", width: 75, sortable: true, dataIndex: 'sequence', css:'padding:5px;'}
  ],
  viewConfig:{forceFit:true}
});

gridDetector.addButton("Add Detector",addDetectorHandler,gridDetector);
gridDetector.addButton("Remove Detector",deleteDetectorHandler,gridDetector);


//------------------------------------------------
// Analog FXO config form
// -----------------------------------------------
function saveFxoConfig(e){
  var owner = e.ownerCt;
  var form = owner.getForm();
  var el = form.getEl();

  el.dom.action = 'config/saveFxoConfig';
  el.dom.method = 'POST';

  var fxoConfig = owner.getItemsValueAsJson();

  form.submit({
    params:{
      'frmAnalogFxo': fxoConfig
    },
    success: function(){
      reloadTree(true);
    },
    failure: Paraxip.failureMessage
  });

};

var frmAnalogFxo = new Ext.FormPanel({
  title           : "Analog FXO config",
  frame           : true,
  header          : false,
  id              : "frmAnalogFxo",
  autoScroll      : true,
  layout        : 'accordion',
  layoutConfig  : {
    activeItem  : 0
  },
  defaults    : {
    layout: 'form',
    style: 'text-align:left;',
    labelWidth: 150,
    bodyStyle: 'padding:5px;',
    width: 500,
    autoHeight: true,
    allowBlank: false,
    fill: true
  },
  buttonAlign     : "right",
  buttons         : [{
    text: 'Disconnection Detector(s)',
    listeners: {
      'click':function(){
        fxoConfigID = idFxo_text.getValue();
        analogFxoDetectorGrid.getStore().load({
          url: 'config/getFxoDetectors',
          params: {'id':fxoConfigID}
        });
        assignAnalogFxoDetectorWindow.show();
      }
    }
  },{
    text: 'Assigned Interface(s)',
    listeners: {
      'click':function(){
        fxoConfigID = idFxo_text.getValue();
        analogFxoBoardsBox.setValue('');
        analogFxoInterfaceBox.setValue('');
        analogFxoChanGroupBox.setValue('');
        analogFxoInterfaceGrid.getStore().load({
          url: 'config/getFxoInterfaces',
          params: {'id':fxoConfigID}
        });
        analogFxoBoardsBox.store.load({
          url: 'config/getBoards',
          params: {'id':fxoConfigID}
        });
        analogFxoChanGroupBox.store.load({
          url: 'config/getChannelGroups',
          params: {'id':fxoConfigID}
        });
        assignAnalogFxoInterfaceWindow.show();
      }
    }
  },{
    text: 'Save',
    listeners: {'click':saveFxoConfig}
  },{
    text: 'Cancel',
    listeners: {'click':callControlCancel}
  }]
});

var fxoConfigPanel = new Ext.Panel({
  id    : 'fxoConfigPanel',
  name  : 'fxoConfig',
  title : 'Configuration Info',
  items : [{
    xtype: 'textfield',
    name: 'nodeId',
    hidden: true,
    hideLabel: true
  }]
});

var inboundCallHandlingPanel = new Ext.Panel({
  id    : 'inboundCallHandlingPanel',
  name  : 'inboundCall',
  title : 'Inbound Call Handling Info'
});

var outboundCallDialingPanel = new Ext.Panel({
  id    : 'outboundCallDialingPanel',
  name  : 'outboundCallDialing',
  title : 'Outbound Dialing Info'
});

var outboundConnectPanel = new Ext.Panel({
  id    : 'outboundConnectPanel',  name  : 'outboundCallConnect',
  title : 'Outbound Connect Info'
});

var disconnectSupervisionPanel = new Ext.Panel({
  id    : 'disconnectSupervisionPanel',
  name  : 'disconnectSupervision',
  title : 'Disconnect Supervision Info'
});

var idFxo_text = createIdText({
  id        : 'idFxo_text',
  helpText  : 'analogFxoConfiganalogFxoConfigID'
});

var nameFxo_text = createNameText({
  id        : 'nameFxo_text',
  helpText  : 'analogFxoConfiganalogFxoConfigdisplayName'
});

var numOfRings_text = new Ext.form.NumberField({
  id          : 'numOfRings_text',
  fieldLabel  : "Number Of Rings",
  name        : "numberOfRings",
  helpText    : "notifyOutboundSideParametersnotifyOutboundSidenumberOfRings",
  allowNegative : false,
  allowBlank  : false,
  disabled    : true,
  width       : 217
});

var notifyOutbound_condition_select = new Ext.form.ComboBox({
  id              : 'notifyOutbound_condition_select',
  name            : 'notifyOutbound_condition',
  fieldLabel      : "Notify Outbound Side Condition",
  store           : ['ON-FIRST-RING','ON-CALLER-ID','AFTER-N-RING'],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  selectOnFocus   : true,
  width           : 200,
  minListWidth    : 200,
  listeners       : {
    'select':function(){
      if( this.getValue() == "AFTER-N-RING") {
        numOfRings_text.enable();
      } else {
        numOfRings_text.disable();
        numOfRings_text.clearInvalid();
      }
    }
  }
});

var notifyOutbound_delay_text = new Ext.form.NumberField({
    id              : 'notifyOutbound_delay_text',
    fieldLabel      : "Notify Outbound Side Delay (ms)",
    name            : "notifyOutbound_delay",
    helpText        : "notifyOutboundSideParametersnotifyOutboundSidedelayInMs",
    allowNegative   : false,
    allowBlank      : false,
    width           : 217
});

var notifyOutboundConnect_condition_select = new Ext.form.ComboBox({
    id              : 'notifyOutboundConnect_condition_select',
    name            : 'connect_condition',
    fieldLabel      : "Connect Inbound Side Condition",
    store           : ['ON-OUTBOUNDSIDE-NOTIFIED','ON-OUTBOUNDSIDE-CONNECTED'],
    forceSelection  : true,
    triggerAction   : 'all',
    mode            : 'local',
    typeAhead       : true,
    selectOnFocus   : true,
    width           : 200,
    minListWidth    : 200
});


var callerID_type_select = new Ext.form.ComboBox({
  id              : 'callerID_type_selection',
  name            : 'callerID_type',
  fieldLabel      : "CallerID Type",
  store           : ['Bellcore-FSK-SDMF-MDMF'],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  selectOnFocus   : true,
  width           : 200,
  minListWidth    : 200
});

var dial_active_select = new Ext.form.ComboBox({
  id              : 'dial_active_selection',
  name            : 'dial_active',
  fieldLabel      : "Active",
  helpText        : "dialParametersdialactive",
  store           : ['YES','NO'],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  selectOnFocus   : true,
  width           : 235,
  minListWidth    : 235
});

var dial_waitForDialTone_select = new Ext.form.ComboBox({
  id              : 'dial_waitForDialTone_selection',
  name            : 'dial_waitForDialTone',
  fieldLabel      : "Wait For Dial Tone",
  helpText        : "dialParametersdialwaitForDialTone",
  store           : ['YES','NO'],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  selectOnFocus   : true,
  width           : 235,
  minListWidth    : 235
});

var preDialDelayInMs_text = new Ext.form.NumberField({
  id          : 'preDialDelayInMs_text',
  fieldLabel  : "Pre Dial Delay (ms)",
  name        : "preDialDelayInMs",
  helpText    : "dialParametersdialpreDialDelayInMs",
  allowNegative : false,
  allowBlank  : false,
  width       : 252
});

var interDigitDelayInMs_text = new Ext.form.NumberField({
  id          : 'interDigitDelayInMs_text',
  fieldLabel  : "InterDigit Delay (ms)",
  name        : "interDigitDelayInMs",
  helpText    : "dialParametersdialinterDigitDelayInMs",
  allowNegative : false,
  allowBlank  : false,
  width       : 252
});

var dTMFDigitDurationInMs_text = new Ext.form.NumberField({
  id          : 'dTMFDigitDurationInMs_text',
  fieldLabel  : "DTMF Digit Duration (ms)",
  name        : "dTMFDigitDurationInMs",
  helpText    : "dialParametersdialDTMFDigitDurationInMs",
  allowNegative : false,
  allowBlank  : false,
  width       : 252
});

var connectOutBoundSide_condition_select = new Ext.form.ComboBox({
  id              : 'connectOutBoundSide_condition_selection',
  name            : 'connectOutBoundSide_condition',
  fieldLabel      : "Connect Outbound Side Condition",
  helpText        : "connectSupervisionParametersconnectSupervisionconnectOutboundSidecondition",
  store           : ['AFTER-DIALING-DESTINATION-NUMBER','ON-VOICE'],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  selectOnFocus   : true,
  width           : 235,
  minListWidth    : 235
});

var connectParamOutbound_condition_select = new Ext.form.ComboBox({
  id              : 'connectParamOutbound_condition_selection',
  name            : 'connectParamOutbound_condition',
  fieldLabel      : "Connect Inbound Side Condition",
  helpText        : "connectParametersOutboundconnectcondition",
  store           : ['ON-OUTBOUNDSIDE-CONNECTED','ON-OUTBOUNDSIDE-NOTIFIED',
                     'ON-INBOUNDSIDE-NOTIFICATION'],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  selectOnFocus   : true,
  width           : 215,
  minListWidth    : 215
});

var connectParamOutbound_delayInMs_text = new Ext.form.NumberField({
  id          : 'connectParamOutbound_delayInMs_text',
  fieldLabel  : "Connect Inbound Side Delay (ms)",
  name        : "connectParamOutbound_delayInMs",
  helpText    : "connectParametersOutboundconnectdelayInMs",
  allowNegative : false,
  allowBlank  : false,
  width       : 232
});

var ringCadenceDetector_active_select = new Ext.form.ComboBox({
  id              : 'ringCadenceDetector_active_selection',
  name            : 'ringCadenceDetector_active',
  fieldLabel      : "Ring Cadence Detector Active",
  helpText        : "disconnectSupervisionParametersdisconnectSupervisiondisconnectDetectorsringCadenceDetectoractive",
  store           : ['YES','NO'],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  selectOnFocus   : true,
  width           : 145,
  minListWidth    : 145
});

var ringCadenceDetector_OffDelayMs_text = new Ext.form.NumberField({
  id          : 'ringCadenceDetector_OffDelayMs_text',
  fieldLabel  : "Ring Cadence Off Delay (ms)",
  name        : "ringCadenceDetector_OffDelayMs",
  helpText        : "disconnectSupervisionParametersdisconnectSupervisiondisconnectDetectorsringCadenceDetectorringCadenceOffDelayMs",
  allowNegative : false,
  allowBlank  : false,
  width       : 162
});

fxoConfigPanel.add(idFxo_text);
fxoConfigPanel.add(nameFxo_text);
frmAnalogFxo.add(fxoConfigPanel);

inboundCallHandlingPanel.add(notifyOutbound_condition_select);
inboundCallHandlingPanel.add(numOfRings_text);
inboundCallHandlingPanel.add(notifyOutbound_delay_text);
inboundCallHandlingPanel.add(notifyOutboundConnect_condition_select);
inboundCallHandlingPanel.add(callerID_type_select);
frmAnalogFxo.add(inboundCallHandlingPanel);

outboundCallDialingPanel.add(dial_active_select);
outboundCallDialingPanel.add(dial_waitForDialTone_select);
outboundCallDialingPanel.add(preDialDelayInMs_text);
outboundCallDialingPanel.add(interDigitDelayInMs_text);
outboundCallDialingPanel.add(dTMFDigitDurationInMs_text);
frmAnalogFxo.add(outboundCallDialingPanel);

outboundConnectPanel.add(connectOutBoundSide_condition_select);
outboundConnectPanel.add(connectParamOutbound_condition_select);
outboundConnectPanel.add(connectParamOutbound_delayInMs_text);
frmAnalogFxo.add(outboundConnectPanel);

disconnectSupervisionPanel.add(ringCadenceDetector_active_select);
disconnectSupervisionPanel.add(ringCadenceDetector_OffDelayMs_text);
frmAnalogFxo.add(disconnectSupervisionPanel);

function applyToFxoConfig(e){
  var grid = e.ownerCt;
  var url;
  var params;
  var gridData;
  var records;
  var i;

  if( grid.getItemId() == "analogFxoInterfaceGrid") {
    url = "config/applyInterfacesToFxoConfig";
    records = grid.getStore().getRange();
    gridData = new Array();
    for (i = 0; i < records.length; i++) {
      gridData.push(records[i].data);
    }
    gridData = Ext.util.JSON.encode(gridData);
    params = {'gridData':gridData,'fxoConfigID':Ext.util.JSON.encode(fxoConfigID)};
  }//TODO - Add FXS

  Ext.Ajax.request({
    url: url,
    method: 'POST',
    disableCaching: false,
    params: params,
    success: function(){
      grid.ownerCt.hide();
      //reloadTree(true);
    },
    failure: Paraxip.failureMessage
  });

};

function addAnalogFxoInterface(e){
  var form = e.ownerCt;
  var values = form.getForm().getValues(false);

  if( form.getForm().isValid()) {
    if( form.id == 'addAnalogFxoInterfaceForm') {
      var newRecord = new DataRecord({
        'boardId':values['boardId'],
        'interfaceId':values['interfaceId'],
        'channelGroupID':values['channelGroupID']
      });
      analogFxoInterfaceGrid.getStore().add(newRecord);
      analogFxoInterfaceGrid.expand();
    }
  }//TODO - Add FXS
};


function deleteFxoInterface(e){
  var grid = e.ownerCt;

  var selectedRecords = grid.getSelectionModel().getSelections();

  if (selectedRecords !== []) {
    for( i = 0; i < selectedRecords.length; i++ ) {
      grid.getStore().remove(selectedRecords[i]);
    }
  }
};

var fxoConfigID = '';

var storeAnalogFxoBoards = new Ext.data.JsonStore({
    id:'storeAnalogFxoBoards',
    url: 'config/getAnalogBoards',
    root: 'data',
    fields: ['id','displayName','nodeId']
});

var storeAnalogFxoInterfaces = new Ext.data.JsonStore({
    id:'storeAnalogFxoInterfaces',
    url: 'config/getAnalogInterfaces',
    root: 'data',
    fields: ['id','displayName']
});

var storeAnalogFxoChannelGroup = new Ext.data.JsonStore({
    id:'storeAnalogFxoChannelGroup',
    url: 'config/getChannelGroups',
    root: 'data',
    fields: ['id']
});

var assignAnalogFxoInterfaceWindow = new Ext.Window({
  title       : 'Assign Analog Interface to Fxo Config',
  layout      : 'accordion',
  layoutConfig : {
      autoWidth:false
  },
  width       : 600,
  height      : 500,
  closeAction : 'hide',
  resizable   : false,
  plain       : true,
  id          : "assignAnalogFxoInterfaceWindow"
});

var analogFxoInterfaceGrid = new Ext.grid.EditorGridPanel({
  title       : 'Analog Interfaces assigned to config',
  id          : 'analogFxoInterfaceGrid',
  autoScroll  : true,
  width       : 500,
  height      : 400,  
  clicksToEdit: 2,
  enableColumnMove : false,
  selModel    : new Ext.grid.RowSelectionModel(),
  store       : new Ext.data.JsonStore({
    id:'storeAnalogFxoInterfaceGrid',
    url: 'config/getFxoInterfaces',
    root: 'data',
    fields: [
      {name: 'boardId'},
      {name: 'interfaceId'},
      {name: 'channelGroupID'},
      {name: 'nodeId'} //not displayed
    ]
  }),
  columns     :[
    {
      header: "Board ID",
      width: 95,
      sortable: true,
      dataIndex: 'boardId',
      editor: new Ext.form.ComboBox({
        forceSelection  : true,
        triggerAction   : 'all',
        mode            : 'local',
        selectOnFocus   : true,
        valueField      : 'id',
        displayField    : 'id',
        store           : storeAnalogFxoBoards,
        listClass       : 'x-combo-list-small'
      })
    },
    {
      header: "Interface ID",
      width: 95,
      sortable: true,
      dataIndex: 'interfaceId',
//    editor: new Ext.form.NumberField({
//      allowNegative  : false,
//      allowBlank  : false
//    })
      editor: new Ext.form.ComboBox({
        forceSelection  : true,
        triggerAction   : 'all',
        mode            : 'local',
        selectOnFocus   : true,
        valueField      : 'id',
        displayField    : 'id',
        store           : storeAnalogFxoInterfaces,
        listClass       : 'x-combo-list-small'
      })
    },
    {
      header: "Channel Group ID",
      width: 105,
      sortable: true,
      dataIndex: 'channelGroupID',
      editor: new Ext.form.ComboBox({
        forceSelection  : true,
        triggerAction   : 'all',
        mode            : 'local',
        selectOnFocus   : true,
        valueField      : 'id',
        displayField    : 'id',
        store           : storeAnalogFxoChannelGroup,
        listClass       : 'x-combo-list-small'
      })
    }
  ],
  listeners       : {
    'afteredit':function(e){
      if( e.field == "boardId" ) {
        var colModel = e.grid.getColumnModel();
        var newColumn = e.column+1;
        var cellEditor = colModel.getCellEditor(newColumn,e.row);
        cellEditor.field.store.load({
          url: 'config/getAnalogInterfaces',
          disableCaching: false,
          params: {'id':e.value}
        });
      }
    }
  },
  viewConfig:{forceFit:true}
});

analogFxoInterfaceGrid.store.on('load',function(store){
  store.each(function(record,index){
                var colModel = analogFxoInterfaceGrid.getColumnModel();
//  var columnIndex = colModel.getIndexById('interfaceId');
    colModel.getCellEditor(1,index).field.store.load({
      url: 'config/getAnalogInterfaces',
      disableCaching: false,
      params: {'id':record.data['boardId']}
    });
  });
});

analogFxoInterfaceGrid.addButton("Delete",deleteFxoInterface,analogFxoInterfaceGrid);
analogFxoInterfaceGrid.addButton("Save",applyToFxoConfig,analogFxoInterfaceGrid);
analogFxoInterfaceGrid.addButton("Cancel",function(){assignAnalogFxoInterfaceWindow.hide();});

var addAnalogFxoInterfaceForm = new Ext.FormPanel({
  id          : "addAnalogFxoInterfaceForm",
  title       : "Add Analog Interface",
  labelWidth  : 130,
  bodyStyle   : "padding:10px;",
  buttonAlign : "right",
  buttons     : [{
    text: "Add",
    listeners: {'click':addAnalogFxoInterface}
  }]
 });

var analogFxoBoardsBox = new Ext.form.ComboBox({
  id              : "analogFxoBoardsBox",
  name            : 'boardId',
  fieldLabel      : "Board ID",
  allowBlank      : false,
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  selectOnFocus   : true,
  valueField      : 'id',
  displayField    : 'id',
 // minListWidth    : 145,
  store           : storeAnalogFxoBoards
});

analogFxoBoardsBox.on('select',function(e,record){
  analogFxoInterfaceBox.clearValue();
  analogFxoInterfaceBox.store.load({
    url: 'config/getAnalogInterfaces',
    disableCaching: false,
    params: {'id':record.data['id']}
  });
});

var analogFxoInterfaceBox = new Ext.form.ComboBox({
  id              : "analogFxoInterfaceBox",
  name            : 'interfaceId',
  fieldLabel      : "Interface ID",
  allowBlank      : false,
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  selectOnFocus   : true,
  valueField      : 'id',
  displayField    : 'id',
  minListWidth    : 145,
  store           : storeAnalogFxoInterfaces
});

var analogFxoChanGroupBox = new Ext.form.ComboBox({
  id              : "analogFxoChanGroupBox",
  name            : 'channelGroupID',
  allowBlank      : false,
  fieldLabel      : "Channel Group ID",
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  selectOnFocus   : true,
  valueField      : 'id',
  displayField    : 'id',
  minListWidth    : 145,
  store           : storeAnalogFxoChannelGroup
});

addAnalogFxoInterfaceForm.add(analogFxoBoardsBox);
addAnalogFxoInterfaceForm.add(analogFxoInterfaceBox);
addAnalogFxoInterfaceForm.add(analogFxoChanGroupBox);

assignAnalogFxoInterfaceWindow.add(analogFxoInterfaceGrid);
assignAnalogFxoInterfaceWindow.add(addAnalogFxoInterfaceForm);

//------------------
function applyFxoDetector(e){
  var grid = e.ownerCt;
  var url;
  var params;
  var gridData;
  var records;
  var i;

  if( grid.getItemId() == "analogFxoDetectorGrid") {
    url = "config/applyDetectorsToFxoConfig";
    records = grid.getStore().getRange();
    gridData = new Array();
    for (i = 0; i < records.length; i++) {
      gridData.push(records[i].data);
    }
    gridData = Ext.util.JSON.encode(gridData);
    params = {'gridData':gridData,'fxoConfigID':Ext.util.JSON.encode(fxoConfigID)};
  }//TODO - Add FXS

  Ext.Ajax.request({
    url: url,
    method: 'POST',
    disableCaching: false,
    params: params,
    success: function(){
      grid.ownerCt.hide();
      reloadTree(true);
    },
    failure: Paraxip.failureMessage
  });

};

function addAnalogFxoDetector(e){
  var form = e.ownerCt;
  var values = form.getForm().getValues(false);

  if( form.id == 'addAnalogFxoDetectorForm') {
    if( values.detector_sequence != '' && values.detector_name != '') {
      var newRecord = new DataRecord({
        'name':values['detector_name'],
        'sequence':values['detector_sequence']
      });
      analogFxoDetectorGrid.getStore().add(newRecord);
      analogFxoDetectorGrid.expand();
    }
  }//TODO - Add FXS
};

function deleteFxoDetector(e){
  var grid = e.ownerCt;

  var selectedRecords = grid.getSelectionModel().getSelections();

  if (selectedRecords !== []) {
    for( i = 0; i < selectedRecords.length; i++ ) {
      grid.getStore().remove(selectedRecords[i]);
    }
  }
};

var storeAnalogFxoDetectors = new Ext.data.JsonStore({
    id:'storeAnalogFxoDetectors',
    url: 'config/getAnalogDetectors',
    root: 'data',
    fields: ['name','sequence']
});

var assignAnalogFxoDetectorWindow = new Ext.Window({
  title       : 'Assign Analog Detector to Fxo Config',
  layout      : 'accordion',
  layoutConfig : {
     autoWidth:false
  },
  width       : 600,
  height      : 500,
  closeAction : 'hide',
  resizable   : false,
  plain       : true,
  id          : "assignAnalogFxoDetectorWindow"
});

var analogFxoDetectorGrid = new Ext.grid.EditorGridPanel({
  title       : 'Analog Detectors assigned to config',
  id          : 'analogFxoDetectorGrid',
  autoScroll  : true,  
  width       : 500,
  height      : 400,
  clicksToEdit: 2,
  selModel    : new Ext.grid.RowSelectionModel(),
  store       : new Ext.data.JsonStore({
    id:'storeAnalogFxoDetectorGrid',
    url: 'config/getFxoDetectors',
    root: 'data',
    fields: [
      {name: 'name'},
      {name: 'sequence'}
    ]
  }),
  columns     :[
    {
      header: "Name",
      width: 95,
      sortable: true,
      dataIndex: 'name',
      editor: new Ext.form.TextField({
        fieldLabel  : "Name",
        name        : "detector_name"
      })
    },
    {
      header: "Sequence",
      width: 95,
      sortable: true,
      dataIndex: 'sequence',
      editor: new Ext.form.TextField({
        fieldLabel  : "Sequence",
        name        : "detector_sequence"
      })
    }
  ],
  viewConfig:{forceFit:true}
});

analogFxoDetectorGrid.addButton("Delete",deleteFxoDetector,analogFxoDetectorGrid);
analogFxoDetectorGrid.addButton("Save",applyFxoDetector,analogFxoDetectorGrid);
analogFxoDetectorGrid.addButton("Cancel",function(){assignAnalogFxoDetectorWindow.hide();});

var addAnalogFxoDetectorForm = new Ext.FormPanel({
  id          : "addAnalogFxoDetectorForm",
  title       : "Add Analog Detector",
  labelWidth  : 130,
  bodyStyle   : "padding:10px;",
  buttonAlign : "right",
  buttons     : [{
    text: "Add",
    listeners: {'click':addAnalogFxoDetector}
  }]
 });

var detector_sequence_text = new Ext.form.TextField({
  id          : 'detector_sequence_text',
  fieldLabel  : "Sequence",
  name        : "detector_sequence",
  helpText    : "disconnectSupervisionParametersdisconnectSupervisiondisconnectDetectorsdetector",
  width       : 162
});


var detector_name_text = new Ext.form.TextField({
  id          : 'detector_name_text',
  fieldLabel  : "Name",
  name        : "detector_name",
  width       : 162
});

addAnalogFxoDetectorForm.add(detector_name_text);
addAnalogFxoDetectorForm.add(detector_sequence_text);

assignAnalogFxoDetectorWindow.add(analogFxoDetectorGrid);
assignAnalogFxoDetectorWindow.add(addAnalogFxoDetectorForm);


